$nocompile
'*******************************************************************************
'  HTTP PHP Call
'*******************************************************************************
'
'  Copyright bascom-forum.de (C) [2009]  [DON]
'  -> http://bascom-forum.de/index.php?topic=1781.new;topicseen#new
'  Software based on Code by Ben Zijlstra and Viktor Varga
'  Weiterentwickelt von
'    Huetti,
'    Michael
'    boeserkorn
'    mr_energy
'    HansHans
'    six1, Michael Kcher
'    dabuze                            datetime
'    framuel
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile

'-------------------------------------------------------------------------------
' Aufruf jede Sekunde von Hauptschleife
'
'-------------------------------------------------------------------------------
Sub Php_compute
             ' einmal am Tag zur Sicherheit die Kiste zurcksetzen
             If Netio_time >= 86400 Then
                 Goto 0
             End If

             If Php_soll_second <= Netio_time Then
               '...plus Zufallswert 0 - 3 min.
               Php_soll_second = Rnd(180)
               Php_soll_second = Php_soll_second + Netio_time
               ' Wartezeit fr nchste PHP Action liegt zwischen Php_base_second und Php_base_second + 3 Minuten
               Php_soll_second = Php_soll_second + Php_base_second
               #if Debug_php_call = 1
                   Print Time(netio_time) ; " - PHP Call Start"
               #endif
               Syn_max = 4   'drei Versuche und danach Reset!
               Syn_count = 1
               Syn_status = 1
               Call Php_send_sync
             Elseif Syn_status = 1 And Syn_count < Syn_max Then
               'wenn der syn nicht beantwortet wird, bis zu syn_max Mal probieren zu kontakten (auf gleichem Port!)
               Incr Syn_count
               'wenn irgend was hngt, Neustart!
               If Syn_count = Syn_max Then
                 Goto 0
               End If
               Call Php_send_sync
             End If
End Sub

'-------------------------------------------------------------------------------
' HTTP Ablaufsteuerung
'   nach ankommenden Flags in TCP werden die Funktionen aufgerufen
'-------------------------------------------------------------------------------
Sub Php
             If Tcp_syn = 1 And Tcp_ack = 1 Then
                Call Php_call_ack
                Syn_status = 2
               #if Debug_php_call = 1
                  Print "  ACK on ACK-SYN"
               #endif
                Call Php_call_site
             Elseif Tcp_fin = 1 And Tcp_ack = 1 Then
                Call Php_call_ack
                Syn_status = 3
               #if Debug_php_call = 1
                  Print "  ACK on ACK-FIN"
               #endif
             Elseif Tcp_psh = 1 And Tcp_ack = 1 Then
                Call Php_call_fin
                Syn_status = 4
               #if Debug_php_call = 1
                  Print "  ACK on ACK-PSH"
               #endif
             Elseif Tcp_rst = 1 And Tcp_ack = 1 Then
                Call Php_send_sync
             End If
End Sub

'-------------------------------------------------------------------------------
' Call_Ack
'  ACK
'-------------------------------------------------------------------------------
Sub Php_call_ack
         Tcp_flags = 0
         Set Tcp_ack
         Call Tcp_swap_seq_ack(tcp_seqnum , Tcp_acknum , 1)
         Call Tcp_swap_ip
         Call Tcp_swap_mac
         Call Tcp_swap_port

         'ENC28J60 doesn't handle Packets with less than 60 Bytes!
         'Option Bytes
         Buffer(55) = 0
         Buffer(56) = 0
         Buffer(57) = 0
         Buffer(58) = 0
         Buffer(59) = 0
         Buffer(60) = 0

         Tcp_hdr = &H50

         Call Set_ip_header_len(54)                         '<-- this will be set to 60 in ENC Routines!!!!
         Call Ip_header_checksum
         Call Tcp_checksum
         Call Enc28j60packetsend(frame_size)                'send it
End Sub

'-------------------------------------------------------------------------------
' Call_fin
'   FIN
'-------------------------------------------------------------------------------
Sub Php_call_fin
         Tcp_flags = 0
         Set Tcp_fin
         Call Tcp_swap_seq_ack(tcp_seqnum , Tcp_acknum , 1)
         Call Tcp_swap_ip
         Call Tcp_swap_mac
         Call Tcp_swap_port

         'ENC28J60 doesn't handle Packets with less than 60 Bytes!
         'Option Bytes
         Buffer(55) = 0
         Buffer(56) = 0
         Buffer(57) = 0
         Buffer(58) = 0
         Buffer(59) = 0
         Buffer(60) = 0

         Tcp_hdr = &H50

         Call Set_ip_header_len(54)
         Call Ip_header_checksum
         Call Tcp_checksum
         Call Enc28j60packetsend(frame_size)                'send it
End Sub

'-------------------------------------------------------------------------------
' SEND_SYNC
'  Einleiten der bertragung
'-------------------------------------------------------------------------------
Sub Php_send_sync
     Call Clear_buffer
     Call Php_tcp_ip_header

#if Debug_php_call = 1
     Print "  Send SYNC  Try: " ; Syn_count ;
#endif

     If Arp_request_destmac_for_ip(my_php_server_ip_addr(1)) = Nok Then
         ' can't connect!!! let's do the ARP request and start a new call after random Time
         #if Debug_php_call = 1
           Print "  No MAC!"
         #endif
         Call Arp_enqueue_ip(my_php_server_ip_addr(1))
         'in 1 Minute nochmal probieren...
         Php_soll_second = Rnd(60)
         Php_soll_second = Php_soll_second + Netio_time
         Exit Sub
     End If

         Tcp_flags = 0
         Set Tcp_syn
         Tcp_seqnum = Netio_time
         Tcp_acknum = 0
         Ip_b_time_to_live = 128

         If Syn_count = 1 Then
           'for retrying SYN we MUST! use same Port
           Php_temp_port = 0
           While Php_temp_port < 10000
             Php_temp_port = Rnd(&Hffff)
           Wend
         End If
         Tcp_srcport = Reversed_word(php_temp_port)

         #if Debug_php_call = 1
           Print " Port: " ; Str(php_temp_port)
         #endif
         'Option Bytes
         Buffer(55) = &H02
         Buffer(56) = &H04
         Buffer(57) = &H05
         Buffer(58) = &HB4
         Buffer(59) = &H01
         Buffer(60) = &H03
         Buffer(61) = &H03
         Buffer(62) = &H02
         Buffer(63) = &H01
         Buffer(64) = &H01
         Buffer(65) = &H04
         Buffer(66) = &H02

         Tcp_hdr = &H80
         Call Set_ip_header_len(66)
         Call Ip_header_checksum
         Call Tcp_checksum
         Call Enc28j60packetsend(66)
End Sub


'-------------------------------------------------------------------------------
' Tcp_ip_header
'  erstellt den TCP/IP Header in "BUFFER"
'-------------------------------------------------------------------------------
Sub Php_tcp_ip_header
      ' *** ETH Header ***
          Eth_b_dest_mac(1) = &HFF
          Eth_b_dest_mac(2) = &HFF
          Eth_b_dest_mac(3) = &HFF
          Eth_b_dest_mac(4) = &HFF
          Eth_b_dest_mac(5) = &HFF
          Eth_b_dest_mac(6) = &HFF

          Eth_b_src_mac(1) = My_b_macaddr(1)
          Eth_b_src_mac(2) = My_b_macaddr(2)
          Eth_b_src_mac(3) = My_b_macaddr(3)
          Eth_b_src_mac(4) = My_b_macaddr(4)
          Eth_b_src_mac(5) = My_b_macaddr(5)
          Eth_b_src_mac(6) = My_b_macaddr(6)

          Eth_w_packettype = Eth_w_packettype_ip

      ' *** IP Header ***
          ' 14     Version=4 (obere 4 Bit)
          '        Headerlen:4-Bit (unter 4-Bit) Wert * 32 Bit = Bytes... Bsp.: 5 * 32Bit = 160Bit / 8 = 20 Byte
          Ip_b_vers_and_length = Ip_standard_vers_and_length
          ' 15     IHL=0 differntiated Service Field
          Ip_b_type_of_service = 0
          ' 16-17  Length IP-Header, TCP-Header and Payload
          Ip_w_packet_length = &H0034                       'Http_stack_headerlength(tempx)
          ' 18-19  Identification, will be incr by 1! fragmented Segmentes!!!
          Ip_w_identifier = &HC426                          'Http_stack_fragment(tempx)
          ' 20-21  always 0x40 0x00
          Ip_w_fragmentation = Reversed_word(&H4000)
          ' 22    Time to live (128)
          Ip_b_time_to_live = 128                           'Http_stack_lifetime(tempx)
          ' 23    TCP Protokoll 0x06
          Ip_b_protocol = Ip_protocol_tcp
          ' 24-25 IP-Header Checksum
          '*** will be generated later on send
          ' 26-29 IP Source Address
          T_ip_srcaddr0 = My_b_ipaddr(1)
          T_ip_srcaddr1 = My_b_ipaddr(2)
          T_ip_srcaddr2 = My_b_ipaddr(3)
          T_ip_srcaddr3 = My_b_ipaddr(4)
          ' 30-33 IP Destination Address
          T_ip_destaddr0 = My_php_server_ip_addr(1)
          T_ip_destaddr1 = My_php_server_ip_addr(2)
          T_ip_destaddr2 = My_php_server_ip_addr(3)
          T_ip_destaddr3 = My_php_server_ip_addr(4)

      ' *** TCP Header ***
          ' 34-35 Source Port
          Tcp_srcportl = 80                                 'Http_stack_port_dest(tempx)
          Tcp_srcporth = 0                                  'Http_stack_port_dest(tempx)
          ' 36-37 Destination Port
          Tcp_destportl = 80                                'Http_stack_port_src(tempx)
          Tcp_destporth = 0                                 'Http_stack_port_src(tempx)
          ' 38-41 Sequnce number
'          Tcp_seqnum = Http_stack_seqnum(tempx)
          Tcp_seqnum = Netio_time                           'Http_stack_acknum(tempx)
          ' 42-45 Acknowledge number
'          Tcp_acknum = Http_stack_acknum(tempx)
          Tcp_acknum = 0                                    'Http_stack_seqnum(tempx)
          ' 46    Header Length  should be always 20 Byte!
          ' (obere 4 Bit) Wert * 32 Bit = Bytes... Bsp.: 5 * 32Bit = 160Bit / 8 = 20 Byte
          Tcp_hdr = &H50
          ' 47    TCP Flags
          Tcp_flags = &H18                                  'PSH, ACK
          ' 48-49 Window Size
          Tcp_win_size = Reversed_word(maxload)
          ' 50-51 TCP Checksum
          '*** will be generated later on send
          ' 52-53 0x0000

         ' Laut RFC 791 muss die TTL von Paketen auf jedem Router,
         ' den das Paket auf dem Weg vom Sender zum Ziel passiert,
         ' um mindestens 1 verringert werden.
         ' IP-Pakete mit einer aktuellen TTL von 0 werden vom Router verworfen.
         Ip_b_time_to_live = 128
End Sub



'-------------------------------------------------------------------------------
' Append_to_dataload
'    hngt String Fragmente an den Ausgabepuffer an
'    und gibt den aktuallisierten Pointer von Buffer zurck
'-------------------------------------------------------------------------------
#if Include_http = 0
Function Append_to_dataload(byref Dataload_pointer As Word , Byval S_s As String ) As Word
   Local W_w As Word
   W_w = Len(s_s)
   If W_w > 0 Then
     W_w = Memcopy(s_s , Tcp_dataload(dataload_pointer) , W_w)
     Dataload_pointer = Dataload_pointer + W_w
   End If
   Append_to_dataload = Dataload_pointer
End Function
#endif

#if Include_http = 0
Sub Set_ip_header_len(byval Headerlen As Word)
     Headerlen = Headerlen - 14                             'Ethernet Buffer abziehen
     T_ip_pktlen0 = High(headerlen)
     T_ip_pktlen1 = Low(headerlen)
End Sub
#endif


'-------------------------------------------------------------------------------
' PHP Site CALL
'-------------------------------------------------------------------------------
Sub Php_call_site
   Local Dataload_pointer As Word
   Local Dummy_l1 As Long , Dummy_l2 As Long
   Local Temp_s As Single
   Local S_s As String * 22
   Local B As Byte

#if Debug_php_call = 1
   Print "  Send Call to PHP Site"
#endif
         Dataload_pointer = 0
         S_s = "GET /" + My_php_script
         Dataload_pointer = Append_to_dataload(dataload_pointer , S_s)
         S_s = "?netionr=" + Str(my_netio_addr)
         Dataload_pointer = Append_to_dataload(dataload_pointer , S_s)
         For B = 1 To Count_temp_pin
             If Status_temp(b) = 0 Then
                Temp_s = Temperatur(b) / 10
                S_s = "&temp" + Str(b) + "="
                S_s = S_s + Fusing(temp_s , "##.#")
             Else
                Temp_s = -100 - Status_temp(b)
                S_s = "&temp" + Str(b) + "=" + Str(temp_s)
             End If
             Dataload_pointer = Append_to_dataload(dataload_pointer , S_s)

         Next

         Dataload_pointer = Append_to_dataload(dataload_pointer , " HTTP/1.1")
         Dataload_pointer = Append_to_dataload(dataload_pointer , Cr_lf)

         S_s = "Host: " + Str(my_php_server_ip_addr(1)) + "." + Str(my_php_server_ip_addr(2)) + "." + Str(my_php_server_ip_addr(3)) + "." + Str(my_php_server_ip_addr(4))
         Dataload_pointer = Append_to_dataload(dataload_pointer , S_s)
         Dataload_pointer = Append_to_dataload(dataload_pointer , Cr_lf)
         Dataload_pointer = Append_to_dataload(dataload_pointer , "User-Agent: ")
         Dataload_pointer = Append_to_dataload(dataload_pointer , "Mozilla/5.0 (Windows; U; Windows NT 6.1;")
         Dataload_pointer = Append_to_dataload(dataload_pointer , " de; rv:1.9.2.3) Gecko/20100401 Firefox/3.6.3")
         Dataload_pointer = Append_to_dataload(dataload_pointer , Cr_lf)
         Dataload_pointer = Append_to_dataload(dataload_pointer , "Accept: ")
         Dataload_pointer = Append_to_dataload(dataload_pointer , "text/html,application/xhtml+xml,")
         Dataload_pointer = Append_to_dataload(dataload_pointer , "application/xml;q=0.9,*/*;q=0.8")
         Dataload_pointer = Append_to_dataload(dataload_pointer , Cr_lf)
         Dataload_pointer = Append_to_dataload(dataload_pointer , "Accept-Language: ")
         Dataload_pointer = Append_to_dataload(dataload_pointer , "de-de,de;q=0.8,en-us;q=0.5,en;q=0.3")
         Dataload_pointer = Append_to_dataload(dataload_pointer , Cr_lf)
         Dataload_pointer = Append_to_dataload(dataload_pointer , "Accept-Encoding: ")
         Dataload_pointer = Append_to_dataload(dataload_pointer , "gzip,deflate")
         Dataload_pointer = Append_to_dataload(dataload_pointer , Cr_lf)
         Dataload_pointer = Append_to_dataload(dataload_pointer , "Accept-Charset: ")
         Dataload_pointer = Append_to_dataload(dataload_pointer , "ISO-8859-1,utf-8;q=0.7,*;q=0.7")
'         Dataload_pointer = Append_to_dataload(dataload_pointer , Cr_lf)
'         Dataload_pointer = Append_to_dataload(dataload_pointer , "Keep-Alive: 115")
'         Dataload_pointer = Append_to_dataload(dataload_pointer , Cr_lf)
'         Dataload_pointer = Append_to_dataload(dataload_pointer , "Connection: keep-alive")
         Dataload_pointer = Append_to_dataload(dataload_pointer , Cr_lf)
         Dataload_pointer = Append_to_dataload(dataload_pointer , "Connection: close")
         Dataload_pointer = Append_to_dataload(dataload_pointer , Cr_lf)
         Dataload_pointer = Append_to_dataload(dataload_pointer , Cr_lf)

         Dataload_pointer = Dataload_pointer + Frame_size

         Tcp_hdr = &H50

         Tcp_flags = 0
         Set Tcp_psh
         Set Tcp_ack

         Call Set_ip_header_len(dataload_pointer)
         Dataload_pointer = Dataload_pointer + 14
         Call Ip_header_checksum
         Call Tcp_checksum
         Call Enc28j60packetsend(dataload_pointer)          'send it
End Sub